﻿
@{
    ViewBag.Title = "Page for API Client";
}

<h2>API client goes here</h2>
<script type="text/javascript" src="~/Scripts/knockout-3.5.0.js"></script>
<script src="~/Scripts/jquery-1.10.2.min.js"></script>

<div class="col col-md-12">
    <table class="table-responsive">
        <thead>
            <tr>
                <td>Code</td>
                <td>Departure</td>
                <td>Destination</td>
                <td>Airlines</td>
                <td></td>
            </tr>
        </thead>
        <tbody data-bind="foreach: flights">
            <tr>
                <td><span data-bind="text: Code"></span></td>
                <td><span data-bind="text: Departure"></span></td>
                <td><span data-bind="text: Destination"></span></td>
                <td><span data-bind="text: Airlines"></span></td>
                <td><input type="button" data-bind="click: $parent.removeFlight" value="X" /></td>
            </tr>
        </tbody>
        <tfoot>
            <tr>
                <td>
                    <input type="text" data-bind="value: flightCode" />
                </td>
                <td>
                    <input type="text" data-bind="value: flightDeparture" />
                </td>
                <td>
                    <input type="text" data-bind="value: flightDestination" />
                </td>
                <td>
                    <input type="text" data-bind="value: flightAirlines" />
                </td>
                <td>
                    <input type="button" data-bind="click: addFlight" value="+" />
                </td>
            </tr>
        </tfoot>
    </table>
</div>

<br /><br /><br />

<div class="col col-md-12">
    <table class="table-responsive">
        <thead>
            <tr>
                <td>Flight</td>
                <td>Row</td>
                <td>Sit</td>
                <td>Class</td>
                <td>BaggageWeight</td>
                <td>LuggageWeight</td>
                <td></td>
            </tr>
        </thead>
        <tbody data-bind="foreach: tickets">
            <tr>
                <td><span data-bind="text: $parent.getFlightCode(FlightId())"></span></td>
                <td><span data-bind="text: Row"></span></td>
                <td><span data-bind="text: Sit"></span></td>
                <td><span data-bind="text: Class"></span></td>
                <td><span data-bind="text: BaggageWeight"></span></td>
                <td><span data-bind="text: LuggageWeight"></span></td>
                <td><input type="button" data-bind="click: $parent.removeTicket" value="X" /></td>
            </tr>
        </tbody>
        <tfoot>
            <tr>
                <td>
                    <select data-bind="options: flights,
                       optionsText: 'Code',
                       optionsValue: 'Id',
                       value: ticketFlightId"></select>
                </td>
                <td>
                    <input type="text" data-bind="value: ticketRow" />
                </td>
                <td>
                    <input type="text" data-bind="value: ticketSit" />
                </td>
                <td>
                    <select data-bind="value: ticketClass">
                        <option value="0">First class</option>
                        <option value="1">Business class</option>
                        <option value="2">Economy class</option>
                    </select>
                </td>
                <td>
                    <input type="text" data-bind="value: ticketBaggageWeight" />
                </td>
                <td>
                    <input type="text" data-bind="value: ticketLuggageWeight" />
                </td>
                <td>
                    <input type="button" data-bind="click: addTicket" value="+" />
                </td>
            </tr>
        </tfoot>
    </table>
</div>


<script>
    function ObservableFlight(id, code, departure, destination, airlines) {
        this.Id = ko.observable(id);
        this.Code = ko.observable(code);
        this.Departure = ko.observable(departure);
        this.Destination = ko.observable(destination);
        this.Airlines = ko.observable(airlines);
    };

    function ObservableTicket(id, flightId, row, sit, sitClass, baggageWeight, luggageWeight) {
        this.Id = ko.observable(id);
        this.FlightId = ko.observable(flightId);
        this.Row = ko.observable(row);
        this.Sit = ko.observable(sit);
        this.Class = ko.observable(sitClass);
        this.BaggageWeight = ko.observable(baggageWeight);
        this.LuggageWeight = ko.observable(luggageWeight);
    };

    function AppViewModel() {
        var self = this;
        self.flights = ko.observableArray([]);
        self.tickets = ko.observableArray([]);
        $.ajax({
            url: "/api/flights",
            method: "GET",
            success: function (data) {
                self.flights(ko.utils.arrayMap(data, function (flight) {
                    return new ObservableFlight(flight.Id, flight.Code, flight.Departure, flight.Destination, flight.Airlines);
                }));

            }
        });

        $.ajax({
            url: "/api/tickets",
            method: "GET",
            success: function (data) {
                self.tickets(ko.utils.arrayMap(data, function (ticket) {
                    return new ObservableTicket(ticket.Id, ticket.FlightId, ticket.Row, ticket.Sit, ticket.Class, ticket.BaggageWeight, ticket.LuggageWeight);
                }));

            }
        });

        self.addFlight = function () {
            $.ajax({
                url: "/api/flights",
                method: "POST",
                data: {
                    Code: self.flightCode,
                    Departure: self.flightDeparture,
                    Destination: self.flightDestination,
                    Airlines: self.flightAirlines
                },
                success: function (data) {
                    self.flights.push(new ObservableFlight(data.Id, data.Code, data.Departure, data.Destination, data.Airlines));
                }
            });
        };

        self.addTicket = function () {
            $.ajax({
                url: "/api/tickets",
                method: "POST",
                data: {
                    FlightId: self.ticketFlightId,
                    Row: self.ticketRow,
                    Sit: self.ticketSit,
                    Class: self.ticketClass,
                    BaggageWeight: self.ticketBaggageWeight,
                    LuggageWeight: self.ticketLuggageWeight,
                },
                success: function (data) {
                    self.tickets.push(new ObservableTicket(data.Id, data.FlightId, data.Row, data.Sit, data.Class, data.BaggageWeight, data.LuggageWeight));
                }
            });
        };

        self.removeFlight = function (flight) {
            $.ajax({
                url: "/api/flights/" + flight.Id(),
                method: "DELETE"
            })
            .done(function (data) {
                self.flights.remove(flight);
            });
        };

        self.removeTicket = function (ticket) {
            $.ajax({
                url: "/api/tickets/" + ticket.Id(),
                method: "DELETE"
            })
            .done(function (data) {
                self.tickets.remove(ticket);
            });
        };

        self.getFlightCode = function (id) {
            var flight = ko.utils.arrayFirst(self.flights(), function (flight) {               
                return flight.Id() == id;
            });
            return flight.Code;
        };

        this.flightCode = ko.observable("");
        this.flightDeparture = ko.observable("");
        this.flightDestination = ko.observable("");
        this.flightAirlines = ko.observable("");

        this.ticketFlightId = ko.observable(0);
        this.ticketRow = ko.observable("");
        this.ticketSit = ko.observable(0);
        this.ticketClass = ko.observable(0);
        this.ticketBaggageWeight = ko.observable(30);
        this.ticketLuggageWeight = ko.observable(8);
    }
    $(function () {
        ko.applyBindings(new AppViewModel());
    });
</script>